<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex38.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex38.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex38.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex38.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 38: Doing Things to Lists</h1>
                <p>You have learned about lists. When you learned about <tt class="docutils literal"><span class="pre">while-loops</span></tt> you &quot;appended&quot; numbers to the end of a list and printed them out.   There were also Study Drills where you were supposed to find all the other things you can do to lists in the Python documentation.  That was a while back, so review those topics if you do not know what I'm talking about.</p>
<p>Found it?  Remember it?  Good.  When you did this you had a list, and you &quot;called&quot; the function <tt class="docutils literal">append</tt> on it.  However, you may not really understand what's going on so let's see what we can do to lists.</p>
<p>When you write <tt class="docutils literal"><span class="pre">mystuff.append('hello')</span></tt> you are actually setting off a chain of events inside Python to cause something to happen to the <tt class="docutils literal">mystuff</tt> list.  Here's how it works:</p>
<ol class="arabic simple">
<li>Python sees you mentioned <tt class="docutils literal">mystuff</tt> and looks up that variable.  It might have to look backward to see if you created with <tt class="docutils literal">=</tt>, if it is a function argument, or if it's a global variable.  Either way it has to find the <tt class="docutils literal">mystuff</tt> first.</li>
<li>Once it finds <tt class="docutils literal">mystuff</tt> it reads the <tt class="docutils literal">.</tt> (period) operator and starts to look at <em>variables</em> that are a part of <tt class="docutils literal">mystuff</tt>.  Since <tt class="docutils literal">mystuff</tt> is a list, it knows that <tt class="docutils literal">mystuff</tt> has a bunch of functions.</li>
<li>It then hits <tt class="docutils literal">append</tt> and compares the name to all the names that <tt class="docutils literal">mystuff</tt> says it owns.  If <tt class="docutils literal">append</tt> is in there (it is) then Python grabs <em>that</em> to use.</li>
<li>Next Python sees the <tt class="docutils literal">(</tt> (parenthesis) and realizes, &quot;Oh hey, this should be a function.&quot; At this point it <em>calls</em> (runs, executes) the function just like normally, but instead it calls the function with an <em>extra</em> argument.</li>
<li>That <em>extra</em> argument is ... <tt class="docutils literal">mystuff</tt>!  I know, weird, right?  But that's how Python works so it's best to just remember it and assume that's the result.  What happens, at the end of all this, is a function call that looks like: <tt class="docutils literal">append(mystuff, 'hello')</tt> instead of what you read which is <tt class="docutils literal"><span class="pre">mystuff.append('hello')</span></tt>.</li>
</ol>
<p>For the most part you do not have to know that this is going on, but it helps when you get error messages from Python like this:</p>
<pre class="code pycon literal-block">
<span class="generic output">$ python
Python 2.6.5 (r265:79063, Apr 16 2010, 13:57:41)
[GCC 4.4.3] on linux2
Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.
</span><span class="keyword"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="keyword">class</span> <span class="name class">Thing</span><span class="punctuation">(</span><span class="name builtin">object</span><span class="punctuation">):</span>
<span class="generic prompt">... </span>    <span class="keyword">def</span> <span class="name function">test</span><span class="punctuation">(</span><span class="name">message</span><span class="punctuation">):</span>
<span class="generic prompt">... </span>            <span class="keyword">print</span> <span class="name">message</span>
<span class="generic prompt">...</span>
<span class="generic prompt">&gt;&gt;&gt; </span><span class="name">a</span> <span class="operator">=</span> <span class="name">Thing</span><span class="punctuation">()</span>
<span class="generic prompt">&gt;&gt;&gt; </span><span class="name">a</span><span class="operator">.</span><span class="name">test</span><span class="punctuation">(</span><span class="literal string double">&quot;hello&quot;</span><span class="punctuation">)</span>
<span class="generic traceback">Traceback (most recent call last):
</span>  File <span class="name builtin">&quot;&lt;stdin&gt;&quot;</span>, line <span class="literal number">1</span>, in <span class="name">&lt;module&gt;</span>
<span class="generic error">TypeError</span>: <span class="name">test() takes exactly 1 argument (2 given)</span>
<span class="generic output">&gt;&gt;&gt;</span>
</pre>
<p>What was all that?  Well, this is me typing into the Python shell and showing you some magic.  You haven't seen <tt class="docutils literal">class</tt> yet but we'll get into that later.  For now you see how Python said <tt class="docutils literal">test() takes exactly 1 argument (2 given)</tt>.  If you see this it means that Python changed <tt class="docutils literal"><span class="pre">a.test(&quot;hello&quot;)</span></tt> to <tt class="docutils literal">test(a, &quot;hello&quot;)</tt> and that somewhere someone messed up and didn't add the argument for <tt class="docutils literal">a</tt>.</p>
<p>This might be a lot to take in, but we're going to spend a few exercises getting this concept firm in your brain.  To kick things off, here's an exercise that mixes strings and lists for all kinds of fun.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex38.py-idio.html-1"></a><span class="n">ten_things</span> <span class="o">=</span> <span class="s2">&quot;Apples Oranges Crows Telephone Light Sugar&quot;</span>
<a name="python--ex38.py-idio.html-2"></a>
<a name="python--ex38.py-idio.html-3"></a><span class="k">print</span> <span class="s2">&quot;Wait there are not 10 things in that list. Let&#39;s fix that.&quot;</span>
<a name="python--ex38.py-idio.html-4"></a>
<a name="python--ex38.py-idio.html-5"></a><span class="n">stuff</span> <span class="o">=</span> <span class="n">ten_things</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39; &#39;</span><span class="p">)</span>
<a name="python--ex38.py-idio.html-6"></a><span class="n">more_stuff</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Day&quot;</span><span class="p">,</span> <span class="s2">&quot;Night&quot;</span><span class="p">,</span> <span class="s2">&quot;Song&quot;</span><span class="p">,</span> <span class="s2">&quot;Frisbee&quot;</span><span class="p">,</span> <span class="s2">&quot;Corn&quot;</span><span class="p">,</span> <span class="s2">&quot;Banana&quot;</span><span class="p">,</span> <span class="s2">&quot;Girl&quot;</span><span class="p">,</span> <span class="s2">&quot;Boy&quot;</span><span class="p">]</span>
<a name="python--ex38.py-idio.html-7"></a>
<a name="python--ex38.py-idio.html-8"></a><span class="k">while</span> <span class="nb">len</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">10</span><span class="p">:</span>
<a name="python--ex38.py-idio.html-9"></a>    <span class="n">next_one</span> <span class="o">=</span> <span class="n">more_stuff</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
<a name="python--ex38.py-idio.html-10"></a>    <span class="k">print</span> <span class="s2">&quot;Adding: &quot;</span><span class="p">,</span> <span class="n">next_one</span>
<a name="python--ex38.py-idio.html-11"></a>    <span class="n">stuff</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">next_one</span><span class="p">)</span>
<a name="python--ex38.py-idio.html-12"></a>    <span class="k">print</span> <span class="s2">&quot;There are </span><span class="si">%d</span><span class="s2"> items now.&quot;</span> <span class="o">%</span> <span class="nb">len</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<a name="python--ex38.py-idio.html-13"></a>
<a name="python--ex38.py-idio.html-14"></a><span class="k">print</span> <span class="s2">&quot;There we go: &quot;</span><span class="p">,</span> <span class="n">stuff</span>
<a name="python--ex38.py-idio.html-15"></a>
<a name="python--ex38.py-idio.html-16"></a><span class="k">print</span> <span class="s2">&quot;Let&#39;s do some things with stuff.&quot;</span>
<a name="python--ex38.py-idio.html-17"></a>
<a name="python--ex38.py-idio.html-18"></a><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex38.py-idio.html-19"></a><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="c1"># whoa! fancy</span>
<a name="python--ex38.py-idio.html-20"></a><span class="k">print</span> <span class="n">stuff</span><span class="o">.</span><span class="n">pop</span><span class="p">()</span>
<a name="python--ex38.py-idio.html-21"></a><span class="k">print</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span> <span class="c1"># what? cool!</span>
<a name="python--ex38.py-idio.html-22"></a><span class="k">print</span> <span class="s1">&#39;#&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">stuff</span><span class="p">[</span><span class="mi">3</span><span class="p">:</span><span class="mi">5</span><span class="p">])</span> <span class="c1"># super stellar!</span>
</pre></div>
</td></tr></table><div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex38.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex38.py
<a name="python--ex38.sh-idio-shint-pyg.html-2"></a><span class="go">Wait there are not 10 things in that list. Let&#39;s fix that.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-3"></a><span class="go">Adding:  Boy</span>
<a name="python--ex38.sh-idio-shint-pyg.html-4"></a><span class="go">There are 7 items now.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-5"></a><span class="go">Adding:  Girl</span>
<a name="python--ex38.sh-idio-shint-pyg.html-6"></a><span class="go">There are 8 items now.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-7"></a><span class="go">Adding:  Banana</span>
<a name="python--ex38.sh-idio-shint-pyg.html-8"></a><span class="go">There are 9 items now.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-9"></a><span class="go">Adding:  Corn</span>
<a name="python--ex38.sh-idio-shint-pyg.html-10"></a><span class="go">There are 10 items now.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-11"></a><span class="go">There we go:  [&#39;Apples&#39;, &#39;Oranges&#39;, &#39;Crows&#39;, &#39;Telephone&#39;, &#39;Light&#39;, &#39;Sugar&#39;, &#39;Boy&#39;, &#39;Girl&#39;, &#39;Banana&#39;, &#39;Corn&#39;]</span>
<a name="python--ex38.sh-idio-shint-pyg.html-12"></a><span class="go">Let&#39;s do some things with stuff.</span>
<a name="python--ex38.sh-idio-shint-pyg.html-13"></a><span class="go">Oranges</span>
<a name="python--ex38.sh-idio-shint-pyg.html-14"></a><span class="go">Corn</span>
<a name="python--ex38.sh-idio-shint-pyg.html-15"></a><span class="go">Corn</span>
<a name="python--ex38.sh-idio-shint-pyg.html-16"></a><span class="go">Apples Oranges Crows Telephone Light Sugar Boy Girl Banana</span>
<a name="python--ex38.sh-idio-shint-pyg.html-17"></a><span class="go">Telephone#Light</span>
</pre></div></div>
<div class="section" id="what-lists-can-do">
<h1>What Lists Can Do</h1>
<p>Let's say you want to create a computer game based on Go Fish.  If you don't know what Go Fish is, take the time now to go read up on it on the internet.  To do this you would need to have some way of taking the concept of a &quot;deck of cards&quot; and put it into your Python program.  You then have to write Python code that knows how to work this imaginary version of a deck of cards so that a person playing your game thinks that it's real, even if it isn't.  What you need is a &quot;deck of cards&quot; structure, and programmers call this kind of thing a &quot;data structure&quot;.</p>
<p>What's a data structure? If you think about it, a &quot;data structure&quot; is just a formal way to <em>structure</em> (organize) some <em>data</em> (facts).  It really is that simple, even though some data structures can get insanely complex, all they are is just a way to store facts inside a program so you can access them in different ways.  They structure data.</p>
<p>I'll be getting into this more in the next exercise, but lists are one of the most common data structures programmers use.  They are simply ordered lists of facts you want to store and access randomly or linearly by an index.  What?!  Remember what I said though, just because a programmer said &quot;list is a list&quot; doesn't mean that it's any more complex than what a list already is in the real world.  Let's look at the deck of cards as an example of a list:</p>
<ol class="arabic simple">
<li>You have a bunch of cards with values.</li>
<li>Those cards are in a stack, list, or list from the top card to the bottom card.</li>
<li>You can take cards off the top, the bottom, the middle at random.</li>
<li>If you want to find a specific card, you have to grab the deck and go through it one at a time.</li>
</ol>
<p>Let's look at what I said:</p>
<dl class="docutils">
<dt>&quot;An ordered list&quot;</dt>
<dd>Yes, deck of cards is in order with a first, and a last.</dd>
<dt>&quot;of things you want to store&quot;</dt>
<dd>Yes, cards are things I want to store.</dd>
<dt>&quot;and access randomly&quot;</dt>
<dd>Yes, I can grab a card from anywhere in the deck.</dd>
<dt>&quot;or linearly&quot;</dt>
<dd>Yes, if I want to find a specific card I can start at the beginning and go in order.</dd>
<dt>&quot;by an index&quot;</dt>
<dd>Almost, since with a deck of cards if I told you to get the card at index 19 you'd have to count until you found that one.  In our Python lists the computer can just jump right to any index you give it.</dd>
</dl>
<p>That is all a list does, and this should give you a way to figure out concepts in programming.  Every concept in programming usually has some relationship to the real world.  At least the useful ones do.  If you can figure out what the analog in the real world is, then you can use that to figure out what the data structure should be able to do.</p>
</div>
<div class="section" id="when-to-use-lists">
<h1>When to Use Lists</h1>
<p>You use a list whenever you have something that matches the list data structure's useful features:</p>
<ol class="arabic simple">
<li>If you need to maintain order. Remember, this is listed order, not <em>sorted</em> order. Lists do not sort for you.</li>
<li>If you need to access the contents randomly by a number. Remember, this is using <em>cardinal</em> numbers starting at 0.</li>
<li>If you need to go through the contents linearly (first to last). Remember, that's what <tt class="docutils literal"><span class="pre">for-loops</span></tt> are for.</li>
</ol>
<p>Then that's when you use a list.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Take each function that is called, and go through the steps for function calls to translate them to what Python does.  For example, <tt class="docutils literal">more_stuff.pop()</tt> is <tt class="docutils literal">pop(more_stuff)</tt>.</li>
<li>Translate these two ways to view the function calls in English.  For example, <tt class="docutils literal">more_stuff.pop()</tt> reads as, &quot;Call <tt class="docutils literal">pop</tt> on <tt class="docutils literal">more_stuff</tt>.&quot;  Meanwhile, <tt class="docutils literal">pop(more_stuff)</tt> means, &quot;Call <tt class="docutils literal">pop</tt> with argument <tt class="docutils literal">more_stuff</tt>.&quot;  Understand how they are really the same thing.</li>
<li>Go read about &quot;object-oriented programming&quot; online.  Confused?  I was too.  Do not worry.  You will learn enough to be dangerous, and you can slowly learn more later.</li>
<li>Read up on what a &quot;class&quot; is in Python.  <em>Do not read about how other languages use the word &quot;class.&quot;</em> That will only mess you up.</li>
<li>Do not worry If you do not have any idea what I'm talking about.  Programmers like to feel smart so they invented object-oriented programming, named it OOP, and then used it way too much.  If you think that's hard, you should try to use &quot;functional programming.&quot;</li>
<li>Find 10 examples of things in the real world that would fit in a list.  Try writing some scripts to work with them.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>Didn't you say to not use <tt class="docutils literal"><span class="pre">while-loops</span></tt>?</dt>
<dd>Yes, so just remember sometimes you can break the rules if you have a good reason.  Only idiots are slaves to rules all the time.</dd>
<dt>Why does <tt class="docutils literal">join(' ', stuff)</tt> not work?</dt>
<dd>The way the documentation for <tt class="docutils literal">join</tt> is written doesn't make sense.  It does not work like that and is instead a method you call on the <em>inserted</em> string to put between the list to be joined.  Rewrite it like <tt class="docutils literal">' '.join(stuff)</tt>.</dd>
<dt>Why did you use a <tt class="docutils literal"><span class="pre">while-loop</span></tt>?</dt>
<dd>Try rewriting it with a <tt class="docutils literal"><span class="pre">for-loop</span></tt> and see if that's easier.</dd>
<dt>What does <tt class="docutils literal">stuff[3:5]</tt> do?</dt>
<dd>That extracts a &quot;slice&quot; from the <tt class="docutils literal">stuff</tt> list that is from element 3 to element 4, meaning it does <em>not</em> include element 5.  It's similar to how <tt class="docutils literal">range(3,5)</tt> would work.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex38.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex38.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
